class MPLNewGameInterimObject expands Info;

var string GameWindowType;

function PostBeginPlay()
{
	local MPLLadderInventory LadderObj;
	local int EmptySlot, j;

	EmptySlot = -1;
	for (j=0; j<5; j++)
	{
		if (class'MPLSlotWindow'.Default.Saves[j] == "") {
			EmptySlot = j;
			break;
		}
	}

	if (EmptySlot < 0)
	{
		// Create "You must first free a slot..." dia//log.
		TournamentConsole(PlayerPawn(Owner).Player.Console).Root.CreateWindow(class'FreeSlotsWindow', 100, 100, 200, 200);
		return;
	}

	// Create new game dia//log.
	TournamentConsole(PlayerPawn(Owner).Player.Console).bNoDrawWorld = True;
	TournamentConsole(PlayerPawn(Owner).Player.Console).bLocked = True;
	UMenuRootWindow(TournamentConsole(PlayerPawn(Owner).Player.Console).Root).MenuBar.HideWindow();

	// Make them a ladder object.
	LadderObj = MPLLadderInventory(PlayerPawn(Owner).FindInventoryType(class'MPLLadderInventory'));
	if (LadderObj == None)
	{
		// Make them a ladder object.
		LadderObj = Spawn(class'MPLLadderInventory');
		//log("Created a new MPLLadderInventory.");
		LadderObj.GiveTo(PlayerPawn(Owner));
	}
	LadderObj.Reset();
	LadderObj.Slot = EmptySlot; // Find a free slot.
	class'MPLManagerWindow'.Default.DOMDoorOpen[EmptySlot] = 0;
	class'MPLManagerWindow'.Default.CTFDoorOpen[EmptySlot] = 0;
	class'MPLManagerWindow'.Default.ASDoorOpen[EmptySlot] = 0;
	class'MPLManagerWindow'.Default.ChalDoorOpen[EmptySlot] = 0;
	class'MPLManagerWindow'.Static.StaticSaveConfig();
	//log("Assigned player a MPLLadderInventory.");

	// Clear all slots.
	Owner.PlaySound(sound'LadderSounds.ladvance', SLOT_None, 0.1);
	Owner.PlaySound(sound'LadderSounds.ladvance', SLOT_Misc, 0.1);
	Owner.PlaySound(sound'LadderSounds.ladvance', SLOT_Pain, 0.1);
	Owner.PlaySound(sound'LadderSounds.ladvance', SLOT_Interact, 0.1);
	Owner.PlaySound(sound'LadderSounds.ladvance', SLOT_Talk, 0.1);
	Owner.PlaySound(sound'LadderSounds.ladvance', SLOT_Interface, 0.1);

	// Go to the character creation screen.
	TournamentConsole(PlayerPawn(Owner).Player.Console).Root.CreateWindow(Class<UWindowWindow>(DynamicLoadObject(GameWindowType, Class'Class')), 100, 100, 200, 200, TournamentConsole(PlayerPawn(Owner).Player.Console).Root, True);
}

defaultproperties
{
     GameWindowType="UT99MPLadder.MPLNewCharacterWindow"
}
